Index: src/main/java/com/tourMate/controllers/HotelController.java
===================================================================
--- src/main/java/com/tourMate/controllers/HotelController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/controllers/HotelController.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -35,5 +35,4 @@
             return ResponseEntity.ok(hoteli);
         } catch (Exception e) {
-            // Handle the exception, log it, and return an error response
             return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(null);
         }
@@ -41,8 +40,6 @@
 
     @GetMapping(path = "/hotel/user/{id}")
-    public ResponseEntity<List<Hotels>> getHotelsForUser (@PathVariable(name = "id") long userId)
-    {
-        try {
-
+    public ResponseEntity<List<Hotels>> getHotelsForUser(@PathVariable(name = "id") long userId) {
+        try {
             List<Hotels> hoteli = hotelManager.getHotelsForUser(userId);
             return ResponseEntity.ok(hoteli);
@@ -53,8 +50,6 @@
 
     @GetMapping(path = "/hotel/{id}/list")
-    public ResponseEntity<Hotels> getHotelById (@PathVariable(name = "id") long hotelId)
-    {
-        try {
-
+    public ResponseEntity<Hotels> getHotelById(@PathVariable(name = "id") long hotelId) {
+        try {
             return ResponseEntity.ok(hotelManager.findHotelByID(hotelId));
         } catch (Exception e) {
@@ -65,6 +60,5 @@
 
     @PostMapping(path = "/hotel/edit")
-    public void edit(@RequestBody Hotels hotel)
-    {
+    public void edit(@RequestBody Hotels hotel) {
         hotelManager.editHotel(hotel.getHotelId(), hotel.getHotelName(), hotel.getHotelDescripiton(), hotel.getHotelLocation(), hotel.getHotelEDBS(), hotel.getParking(), hotel.getPetFriendly(), hotel.getInternetAvailable());
     }
@@ -72,15 +66,11 @@
     @GetMapping(path = "/hotel/delete")
     public ResponseEntity remove(@RequestParam(name = "hotelId") long hotelId) {
-        try
-        {
+        try {
             hotelManager.deleteHotel(hotelId);
             return new ResponseEntity(HttpStatus.OK);
-        }
-        catch (Exception exception)
-        {
-            return new ResponseEntity(HttpStatus.NOT_FOUND);
-        }
-    }
-
+        } catch (Exception exception) {
+            return new ResponseEntity(HttpStatus.NOT_FOUND);
+        }
+    }
 
 
@@ -90,6 +80,5 @@
             hotelManager.deleteHotelImage(hotelId);
             return new ResponseEntity(HttpStatus.OK);
-        }
-        catch (Exception exception) {
+        } catch (Exception exception) {
             return new ResponseEntity(HttpStatus.NOT_FOUND);
         }
@@ -97,6 +86,5 @@
 
     @GetMapping(path = "/hotel/{id}/room")
-    public List<HotelRoom> getHotelRooms(@PathVariable(value = "id") long hotelId)
-    {
+    public List<HotelRoom> getHotelRooms(@PathVariable(value = "id") long hotelId) {
         System.out.println("ovde so id: " + hotelId);
         return hotelManager.getRoomsOfHotel(hotelId);
@@ -108,6 +96,5 @@
     public void addRoom(@RequestBody HotelRoom room,
                         @RequestParam(name = "hotelId") long hotelId) {
-        Hotels h = hotelManager.findHotelByID(hotelId);
-        hotelManager.createRoom(h, room.getHotelRoomDescription(), room.getHotelRoomName(), room.getKitchenAvailable(), room.getAirConditioning(), room.getBalcony(), room.getPrice(), room.getNumOfBeds());
+        hotelManager.createRoom(hotelId, room.getHotelRoomDescription(), room.getHotelRoomName(), room.getKitchenAvailable(), room.getAirConditioning(), room.getBalcony(), room.getPrice(), room.getNumOfBeds());
     }
 
@@ -119,11 +106,8 @@
     @GetMapping(path = "/hotel/rooms/delete")
     public ResponseEntity removeRoom(@RequestParam(name = "hotelRoomId") long hotelRoomId) {
-        try
-        {
+        try {
             hotelManager.deleteRoom(hotelRoomId);
             return new ResponseEntity(HttpStatus.OK);
-        }
-        catch (Exception exception)
-        {
+        } catch (Exception exception) {
             return new ResponseEntity(HttpStatus.NOT_FOUND);
         }
@@ -139,40 +123,31 @@
     @GetMapping(path = "/hotel/rooms/reservation/delete")
     public ResponseEntity removeReservation(@RequestParam(name = "hotelRoomReservationId") long hotelRoomReservationId) {
-        try
-        {
+        try {
             hotelManager.deleteReservation(hotelRoomReservationId);
             return new ResponseEntity(HttpStatus.OK);
-        }
-        catch (Exception exception)
-        {
-            return new ResponseEntity(HttpStatus.NOT_FOUND);
-        }
-    }
-
-        //HOTEL AVAILABILITY CRUD
+        } catch (Exception exception) {
+            return new ResponseEntity(HttpStatus.NOT_FOUND);
+        }
+    }
+
+    //HOTEL AVAILABILITY CRUD
     @PostMapping(path = "/hotel/rooms/available/{id}/add")
     public void addRoomAvailible(@RequestBody HotelRoomAvailable hotelRoomAvailable,
-                                 @PathVariable long id)
-    {
-        HotelRoom hotelRoom = hotelManager.findRoomById(id);
-        hotelManager.createRoomAvailible(hotelRoom, hotelRoomAvailable.getDateFrom(), hotelRoomAvailable.getDateTo(), hotelRoomAvailable.getNumberOfBeds());
+                                 @PathVariable long id) {
+
+        hotelManager.createRoomAvailible(id, hotelRoomAvailable.getDateFrom(), hotelRoomAvailable.getDateTo(), hotelRoomAvailable.getNumberOfBeds());
     }
 
     @PostMapping(path = "/hotel/rooms/available/edit")
-    public void editRoomAvailible(@RequestBody HotelRoomAvailable hotelRoomAvailable)
-    {
+    public void editRoomAvailible(@RequestBody HotelRoomAvailable hotelRoomAvailable) {
         hotelManager.editRoomAvailible(hotelRoomAvailable.getHotelRoomAvailableId(), hotelRoomAvailable.getHotelRoom(), hotelRoomAvailable.getDateFrom(), hotelRoomAvailable.getDateTo(), hotelRoomAvailable.getNumberOfBeds());
     }
 
     @GetMapping(path = "/hotel/rooms/available/remove")
-    public ResponseEntity removeRoomAvailible(@RequestParam(name = "hotelRoomAvailibleId") long hotelRoomAvailibleId)
-    {
-        try
-        {
+    public ResponseEntity removeRoomAvailible(@RequestParam(name = "hotelRoomAvailibleId") long hotelRoomAvailibleId) {
+        try {
             hotelManager.deleteRoomAvailible(hotelRoomAvailibleId);
             return new ResponseEntity(HttpStatus.OK);
-        }
-        catch (Exception ex)
-        {
+        } catch (Exception ex) {
             return new ResponseEntity(HttpStatus.NOT_FOUND);
         }
@@ -180,6 +155,5 @@
 
     @GetMapping(path = "hotel/rooms/{id}/available")
-    public List<HotelRoomAvailable> getRoomAvailability(@PathVariable Long id)
-    {
+    public List<HotelRoomAvailable> getRoomAvailability(@PathVariable Long id) {
         return hotelManager.getRoomsAvailableById(id);
     }
@@ -190,19 +164,15 @@
                                                @RequestParam(name = "dateTo") @DateTimeFormat(pattern = "yyyy-MM-dd") Date dateTo,
                                                @RequestParam(name = "numBeds") int numBeds,
-                                               @RequestParam(name = "flexible") Boolean flexible)
-    {
-        System.out.println(flexible);
-        System.out.println(dateFrom + " " + dateTo);
+                                               @RequestParam(name = "flexible") Boolean flexible) {
         return hotelManager.getRoomsAvailibilityByDateAndLocation(hotelLocation, dateFrom, dateTo, numBeds, flexible);
     }
 
     @PostMapping(path = "/hotel/reserve")
-    public void reserveHotelRoom(@RequestParam(name = "hotelRoomId")Long hotelRoomId,
+    public void reserveHotelRoom(@RequestParam(name = "hotelRoomId") Long hotelRoomId,
                                  @RequestParam(name = "userId") Long userId,
                                  @RequestParam(name = "hotelRoomAvailableId") Long hotelRoomAvailableId,
                                  @RequestParam(name = "numberOfBeds") Integer numberOfBeds,
                                  @RequestParam(name = "from") @DateTimeFormat(iso = DateTimeFormat.ISO.DATE) Date from,
-                                 @RequestParam(name = "to") @DateTimeFormat(iso = DateTimeFormat.ISO.DATE) Date to){
-
+                                 @RequestParam(name = "to") @DateTimeFormat(iso = DateTimeFormat.ISO.DATE) Date to) {
 
 
@@ -211,35 +181,30 @@
 
     @GetMapping(path = "/hotel/{id}/reservations/active")
-    public List<HotelReservationDto> getActiveReservationsForHotel(@PathVariable Long id)
-    {
+    public List<HotelReservationDto> getActiveReservationsForHotel(@PathVariable Long id) {
         return hotelManager.findVaidReseravtionsByHotel(id);
     }
 
     @GetMapping(path = "/hotel/reservations/user/{id}")
-    public List<HotelReservationUserDto> getActiveReservationsForUser(@PathVariable Long id)
-    {
+    public List<HotelReservationUserDto> getActiveReservationsForUser(@PathVariable Long id) {
         return hotelManager.findValidHotelReservationsByUser(id);
     }
 
     @GetMapping(path = "/hotel/reservations/user/{id}/past")
-    public List<HotelReservationUserDto> getPastReservationsForUser(@PathVariable Long id)
-    {
+    public List<HotelReservationUserDto> getPastReservationsForUser(@PathVariable Long id) {
         return hotelManager.findPastHotelReservationsByUser(id);
     }
 
     @GetMapping(path = "/hotel/{id}/images")
-    public List<HotelsImages> getImagesForHotel(@PathVariable Long id)
-    {
+    public List<HotelsImages> getImagesForHotel(@PathVariable Long id) {
         return hotelManager.getHotelImages(id);
     }
 
     @GetMapping(path = "/room/{id}/images")
-    public List<HotelRoomImages> getImagesForHotelRoom(@PathVariable Long id)
-    {
+    public List<HotelRoomImages> getImagesForHotelRoom(@PathVariable Long id) {
         return hotelManager.getRoomImages(id);
     }
 
     @PostMapping("/hotel/{id}/cancel")
-    public void cancelHotelReservation(@PathVariable Long id){
+    public void cancelHotelReservation(@PathVariable Long id) {
         hotelManager.deleteReservation(id);
     }
Index: src/main/java/com/tourMate/controllers/RestaurantController.java
===================================================================
--- src/main/java/com/tourMate/controllers/RestaurantController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/controllers/RestaurantController.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -6,4 +6,5 @@
 import com.tourMate.dto.RestaurantReservationUserDto;
 import com.tourMate.entities.*;
+import com.tourMate.services.MenuManager;
 import com.tourMate.services.RestaurantManager;
 import org.springframework.beans.factory.annotation.Autowired;
@@ -23,4 +24,6 @@
     @Autowired
     RestaurantManager restaurantManager;
+    @Autowired
+    MenuManager menuManager;
 
     @PostMapping(path = "/restaurant/add")
@@ -34,4 +37,13 @@
     public void addMenu(@PathVariable(name = "id") long restaurantId, @RequestBody Menu menu) {
         restaurantManager.addMenuToRestaurant(restaurantId, menu);
+    }
+
+    @PostMapping(path = "/menu/{id}/edit")
+    public void editMenu(@PathVariable Long id,
+                         @RequestParam String name,
+                         @RequestParam String ingredients,
+                         @RequestParam double price)
+    {
+        menuManager.editMenu(id, name, ingredients, price);
     }
 
@@ -149,13 +161,6 @@
                                                          @RequestParam(name = "hourTo") String hourTo,
                                                          @RequestParam(name = "numPeople") int noSeats) {
-        Date dateFrom = date;
-        Date dateTo = Date.from(date.toInstant());
-        String[] splittedFrom = hourFrom.split(":");
-        String[] splittedTo = hourTo.split(":");
-        dateFrom.setHours(Integer.parseInt(splittedFrom[0]));
-        dateFrom.setMinutes(Integer.parseInt(splittedFrom[1]));
-        dateTo.setHours(Integer.parseInt(splittedTo[0]));
-        dateTo.setMinutes(Integer.parseInt(splittedTo[1]));
-        return restaurantManager.getTablesByDateAndLocation(restaurantLocation, dateFrom, dateTo, noSeats);
+
+        return restaurantManager.getTablesByDateAndLocation(restaurantLocation, date, hourFrom, hourTo, noSeats);
     }
 
Index: src/main/java/com/tourMate/controllers/ReviewController.java
===================================================================
--- src/main/java/com/tourMate/controllers/ReviewController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/controllers/ReviewController.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -28,5 +28,4 @@
     public void edit(@RequestBody Reviews review)
     {
-//        editReview(long id, String title, String description, int numStar, Hotels hotel, Restaurants restaurant, Transport transport)
         reviewManager.editReview(review.getReviewId(), review.getTitle(), review.getDescription(), review.getNumStar(), review.getHotel(), review.getRestaurant(), review.getTransport());
     }
Index: src/main/java/com/tourMate/controllers/TransportController.java
===================================================================
--- src/main/java/com/tourMate/controllers/TransportController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/controllers/TransportController.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -84,11 +84,6 @@
     @PostMapping(path = "/transport/available/add")
     public void add(@RequestBody TransportAvailible transportAvailable, @RequestParam(name = "transportId") long transportId) {
-        Transport t = transportManager.getTransportById(transportId);
-        List<TransportRoute> routes = transportAvailable.getRoutes().stream().toList();
-        routes.get(0).setDeparture(transportAvailable.getDate());
-        transportAvailable.setTime(routes.get(routes.size() - 1).getArrival());
-        routes.forEach(x -> x.setParentRoute(transportAvailable));
-        transportAvailable.setTransport(t);
-        transportManager.createTransportAvailable(transportAvailable.getTransport(), transportAvailable.getFrom(), transportAvailable.getTo(), transportAvailable.getDate(), transportAvailable.getFreeSpace(), transportAvailable.getTime(), routes);
+
+        transportManager.createTransportAvailable(transportAvailable, transportAvailable.getTransport(), transportAvailable.getFrom(), transportAvailable.getTo(), transportAvailable.getDate(), transportAvailable.getFreeSpace(), transportAvailable.getTime(), transportId, transportAvailable.getRoutes());
     }
 
Index: src/main/java/com/tourMate/controllers/UsersController.java
===================================================================
--- src/main/java/com/tourMate/controllers/UsersController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/controllers/UsersController.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -1,6 +1,8 @@
 package com.tourMate.controllers;
 
+import com.tourMate.dto.PrincipalInfo;
 import com.tourMate.entities.Business;
 import com.tourMate.entities.User;
+import com.tourMate.config.oauth2.OAuth2UserDetailsCustom;
 import com.tourMate.services.BusinessManager;
 import com.tourMate.services.UsersManager;
@@ -9,4 +11,5 @@
 import org.springframework.http.ResponseEntity;
 import org.springframework.security.core.Authentication;
+import org.springframework.security.core.parameters.P;
 import org.springframework.web.bind.annotation.*;
 
@@ -57,6 +60,4 @@
         usersManager.approveUserProfile(userId);
         return new ResponseEntity<>(HttpStatus.OK);
-
-
     }
 
@@ -70,5 +71,4 @@
     @PostMapping(path = "/register")
     public List<User> add(@RequestBody User user) {
-        System.out.println(user.getName() + user.getSurname());
         usersManager.createUser(user.getName(), user.getSurname(), user.getEmail(), user.getBirthDate(), user.getAddress(), user.getContact());
         return usersManager.getCreatedUsers();
@@ -88,34 +88,57 @@
     @GetMapping(value = "/principal")
     @ResponseBody
-    public User currentUser(Authentication authentication) {
-        return (User) authentication.getPrincipal();
+    public PrincipalInfo currentUser(Authentication authentication) {
+        Long id;
+        if(authentication.getPrincipal() instanceof OAuth2UserDetailsCustom)
+        {
+            OAuth2UserDetailsCustom oAuth2UserDetailsCustom = (OAuth2UserDetailsCustom) authentication.getPrincipal();
+            id = oAuth2UserDetailsCustom.getId();
+        }
+        else
+        {
+            User user = (User) authentication.getPrincipal();
+            id = user.getUserID();
+        }
+        return usersManager.getPrincipalInfo(id);
     }
     @PostMapping(path = "/user/edit")
-    public List<User> edit(@RequestBody User user)
+    public void edit(@RequestBody User user)
     {
-        System.out.println(user.getName() + " " + user.getSurname() + "id e " + user.getUserID());
-        // long userID, String name, String surname, String email, Date birthDate, String address, String contact
         usersManager.editUser(user.getUserID(), user.getName(), user.getSurname(), user.getEmail(), user.getBirthDate(), user.getAddress(), user.getContact());
-        return usersManager.getCreatedUsers();
     }
 
     @GetMapping(path = "/user/delete")
-    public ResponseEntity remove(@RequestParam(name = "userId") long userId) {
+    public ResponseEntity<?> remove(@RequestParam(name = "userId") long userId) {
         try
         {
             usersManager.deleteUser(userId);
-            return new ResponseEntity(HttpStatus.OK);
+            return new ResponseEntity<>(HttpStatus.OK);
         }
         catch (Exception exception)
         {
-            return new ResponseEntity(HttpStatus.NOT_FOUND);
+            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
         }
     }
 
     @GetMapping("/users/unlock/{id}")
-    public ResponseEntity unlock(@PathVariable Long id)
+    public ResponseEntity<?> unlock(@PathVariable Long id)
     {
         usersManager.unlock(id);
-        return new ResponseEntity(HttpStatus.OK);
+        return new ResponseEntity<>(HttpStatus.OK);
+    }
+
+    @PostMapping("/users/{id}/connect")
+    public ResponseEntity<?> connectAccount(@PathVariable Long id,
+                                            @RequestParam String username,
+                                            @RequestParam String password)
+    {
+        usersManager.connectAccount(id, username, password);
+        return new ResponseEntity<>(HttpStatus.OK);
+    }
+
+    @GetMapping("/users/{id}/connected")
+    public List<User> getConnectedAccounts(@PathVariable Long id)
+    {
+        return usersManager.findConnectedAccountsByUser(id);
     }
 }
Index: src/main/java/com/tourMate/controllers/UtilsController.java
===================================================================
--- src/main/java/com/tourMate/controllers/UtilsController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/controllers/UtilsController.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -2,4 +2,5 @@
 
 import org.springframework.http.ResponseEntity;
+import org.springframework.stereotype.Controller;
 import org.springframework.web.bind.annotation.GetMapping;
 import org.springframework.web.bind.annotation.RestController;
@@ -10,15 +11,10 @@
 import java.net.http.HttpResponse;
 
-@RestController
+@Controller
 public class UtilsController {
-    @GetMapping("/loo")
-    public ResponseEntity<?> testFnc(RedirectAttributes attributes) {
-        String redirectUrl = "https://example.com"; // Replace with your desired redirect URL
-
-        // Using UriComponentsBuilder to handle URL encoding
-        return ResponseEntity
-                .status(302) // 302 Found status code for redirect
-                .location(UriComponentsBuilder.fromUriString(redirectUrl).build().toUri())
-                .build();
+    @GetMapping("/login")
+    public String getLoginPage()
+    {
+        return "login";
     }
 }
Index: src/main/java/com/tourMate/dao/HotelDao.java
===================================================================
--- src/main/java/com/tourMate/dao/HotelDao.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/HotelDao.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -97,4 +97,6 @@
 
     List<HotelRoomReservations> findPastReservationByUser(User u);
+
+    List<HotelRoomReservations> getReservationsInPeriod(String hotelLocation, Date dateFrom, Date dateTo);
 //    public void createHotel(Hotels hotel, long userId);
 //    public void editHotel(long hotelId, String hotelName, String hotelDescripiton, String hotelLocation, String hotelEDBS, Boolean parking, Boolean petFriendly, Boolean internetAvailable);
Index: src/main/java/com/tourMate/dao/TransportDao.java
===================================================================
--- src/main/java/com/tourMate/dao/TransportDao.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/TransportDao.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -1,6 +1,4 @@
 package com.tourMate.dao;
 
-import com.tourMate.dto.RouteListingDto;
-import com.tourMate.dto.TransportDto;
 import com.tourMate.entities.*;
 import jakarta.transaction.Transactional;
@@ -19,9 +17,9 @@
     List<Transport> getTransports();
 
-    List<TransportDto> getTransportsByUser(User u);
+    List<Transport> getTransportsByUser(User u);
 
-    List<RouteListingDto> getRoutesForTransport(Transport t);
+    List<TransportAvailible> getRoutesForTransport(Transport t);
 
-    TransportDto findTransportById(long transportId);
+    Transport findTransportById(long transportId);
 
     Transport getTransportById(long transportId);
Index: src/main/java/com/tourMate/dao/UsersDao.java
===================================================================
--- src/main/java/com/tourMate/dao/UsersDao.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/UsersDao.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -1,6 +1,8 @@
 package com.tourMate.dao;
 
+import com.tourMate.entities.Providers;
 import com.tourMate.entities.Role;
 import com.tourMate.entities.User;
+import jakarta.transaction.Transactional;
 import org.springframework.security.core.userdetails.UserDetails;
 
@@ -29,4 +31,12 @@
 
     Role findById(Long id);
-    void updateUser(User s);
+    User updateUser(User s);
+    User findByUsernameAndProvider(String username, String providers);
+
+    @Transactional
+    User mergeUser(User user);
+
+    List<User> getAdmins();
+
+    List<User> findConnectedAccountsByUser(User u);
 }
Index: src/main/java/com/tourMate/dao/impl/BusinessDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/BusinessDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/impl/BusinessDaoImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -4,7 +4,10 @@
 import com.tourMate.entities.Business;
 import com.tourMate.entities.User;
+import com.tourMate.events.OnBusinessApprovedEvent;
 import jakarta.persistence.EntityManager;
 import jakarta.persistence.PersistenceContext;
 import jakarta.transaction.Transactional;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.context.ApplicationEventPublisher;
 import org.springframework.stereotype.Service;
 
@@ -16,4 +19,6 @@
     @PersistenceContext
     EntityManager em;
+    @Autowired
+    ApplicationEventPublisher eventPublisher;
 
     @Transactional
@@ -37,5 +42,8 @@
     public boolean hasBusiness(User u)
     {
-        return Integer.parseInt(em.createQuery("SELECT COUNT(b) FROM Business b WHERE b.user = :user").setParameter("user", u).getSingleResult().toString()) > 0;
+        return Integer.parseInt(em.createQuery("SELECT COUNT(b) FROM Business b WHERE b.user = :user or b.user in :users")
+                .setParameter("user", u)
+                .setParameter("users", u.getConnectedAccounts())
+                .getSingleResult().toString()) > 0;
     }
 
@@ -49,4 +57,5 @@
     public void approveBusiness(Business b) {
         em.persist(b);
+        eventPublisher.publishEvent(new OnBusinessApprovedEvent(b.getUser()));
     }
 
Index: src/main/java/com/tourMate/dao/impl/HotelDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/HotelDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/impl/HotelDaoImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -3,7 +3,11 @@
 import com.tourMate.dao.HotelDao;
 import com.tourMate.entities.*;
+import com.tourMate.events.OnHotelReservationEvent;
+import com.tourMate.events.OnRegistrationSuccessEvent;
 import jakarta.persistence.EntityManager;
 import jakarta.persistence.PersistenceContext;
 import jakarta.transaction.Transactional;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.context.ApplicationEventPublisher;
 import org.springframework.stereotype.Service;
 
@@ -17,4 +21,6 @@
     @PersistenceContext
     EntityManager em;
+    @Autowired
+    ApplicationEventPublisher eventPublisher;
 
     @Override
@@ -31,12 +37,9 @@
     @Override
     public List<Hotels> getHotelsForUser(User u) {
-        return em.createQuery("select h from Hotels h where h.owner = :u").setParameter("u", u).getResultList();
-    }
-
-    @Override
-    public List<Hotels> getHotelsByLocation(String hotelLocation) {
-        return em.createQuery("select h from Hotels h where h.hotelLocation = hotelLocation").getResultList();
-    }
-
+        return em.createQuery("select h from Hotels h where h.owner = :u or h.owner in :users")
+                .setParameter("u", u)
+                .setParameter("users", u.getConnectedAccounts())
+                .getResultList();
+    }
     @Transactional
     @Override
@@ -211,7 +214,4 @@
         }
 
-
-
-
     }
 
@@ -232,4 +232,5 @@
     public void createReservation(HotelRoomReservations  r) {
         em.persist(r);
+        eventPublisher.publishEvent(new OnHotelReservationEvent(r.getUser(), r));
     }
 
@@ -243,5 +244,4 @@
     @Override
     public void deleteReservation(HotelRoomReservations hr) {
-
         em.remove(hr);
     }
@@ -281,3 +281,20 @@
                 .setParameter("user", u).getResultList();
     }
+
+    @Override
+    public List<HotelRoomReservations> getReservationsInPeriod(String hotelLocation, Date dateFrom, Date dateTo) {
+        return em.createQuery("select hr from HotelRoomReservations hr where hr.hotelRoom.hotel.hotelLocation like :hotelLocation and (hr.dateFrom between :dateFrom and :dateTo) or (hr.dateTo between :dateFrom and :dateTo)")
+                .setParameter("hotelLocation", hotelLocation)
+                .setParameter("dateFrom", dateFrom)
+                .setParameter("dateTo", dateTo)
+                .getResultList();
+    }
+
+    @Override
+    public List<Hotels> getHotelsByLocation(String hotelLocation)
+    {
+        return em.createQuery("select h from Hotels h where h.hotelLocation like :hotelLocation")
+                .setParameter("hotelLocation", hotelLocation)
+                .getResultList();
+    }
 }
Index: src/main/java/com/tourMate/dao/impl/RestaurantDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/RestaurantDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/impl/RestaurantDaoImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -102,5 +102,8 @@
     @Override
     public List<Restaurant> getRestaurantsByUser(User u) {
-        return em.createQuery("select r from Restaurant r where r.restaurantOwner = :u").setParameter("u", u).getResultList();
+        return em.createQuery("select r from Restaurant r where r.restaurantOwner = :u or r.restaurantOwner in :users")
+                .setParameter("u", u)
+                .setParameter("users", u.getConnectedAccounts())
+                .getResultList();
     }
 
